вторник, 18 августа 2009 г.

К вопросу о update/upgrade

/*
... если Ваша программа таки
заработала - то это просто СЧАСТЬЕ...
/Linus Torvalds, вольный перевод/

на сей опус подвигли многочисленные заявления о сокращении сроков поддержки релизов и т.п.. плохо это или хорошо - не мне судить, но ключевой выбор openSUSE/SuSE/SLE* как платформы для изучения/использования/экспериментов в основном обусловлен КАЧЕСТВОМ самого дистрибутива и схемой поддержки (включая латание дыр и т.п.).

на кону у нас очередной "multiple guess question": - "а стоит ли переползать на грядущую openSUSE-11.2?" imho - настоящие джедаи делают "zypper dup" только после kernel upgrade-а в новой версии, или же спустя 2-3 месяца после выхода (да и то по обстоятельствам). о том, каково оно - "переход на новую версию" - писал ранее.

на данный момент в openSUSE-11.1 (oS-11.1) используется стабильная версия ядра 2.6.27.* и для многих пользователей "фишки" новых ядер представляются более предпочтительными. "не вопрос!" с недавних пор в OBS появились новые чудные репо:

Moblin Base
Moblin

где предлагают Вашему вниманию довольно сырой и нестабильный интерфейс, основанный на clutter. это собсно прообраз gnome-3.* и до выхода релиза пользовать его не рекомендуется (ессно для незаинтересованных граждан).

по сути своей интерфейс Moblin очень напоминает "illume" модуль Enlightenment-DR17 по заложенным концепциям. по крайней мере все принципы построения интерфейса "честно" слизаны с illume, что не может не радовать. после добавления указанных выше репо есть возможность поставить себе kernel-2.6.30.5 (последний стабильный релиз) и попробовать его как основу для своей системы. есть пара-тройка моментов, не более. теперь по-порядку:

1) для сукесфули (successfully) ребута в "/etc/modprobe.d/*" все файлы должны иметь расширение "*.conf" (тупенько ручками пририсуем к имени файла это расширение...).

2) убедиться, что поставили "полный фарш":

kernel-default-2.6.30.5-16.1
kernel-default-base-2.6.30.5-16.1
kernel-default-devel-2.6.30.5-16.1
kernel-default-extra-2.6.30.5-16.1
kernel-firmware-20090421.1-5.1
kernel-source-2.6.30.5-16.1
kernel-syms-2.6.30.5-16.1

3) поддержка reiserfs4 чарующе элегантна (как обычно впрочем...):

> wget http://download.opensuse.org/repositories/home:/jeff_mahoney/openSUSE_Factory/src/reiser4-0.1-29.2.src.rpm
> rpmbuild --rebuild ./reiser4-0.1-29.2.src.rpm
> sudo rpm -Uhv /usr/src/packages/RPMS/$ARCH/reiser4-kmp-default-0.1_2.6.30.5_16-29.2.i586.rpm

4) крайне желательно проапгрейдить "e2fsprogs":

> rm /usr/src/packages/RPMS/$ARCH/e2fsprogs*
> wget http://prdownloads.sourceforge.net/e2fsprogs/e2fsprogs-1.41.8.tar.gz
> tar xfm ./e2fsprogs-1.41.8.tar.gz
> cd ./e2fsprogs-1.41.8 && ./configure && cd ../
> ln -s "`pwd`"/e2fsprogs-1.41.8.tar.gz /usr/src/packages/SOURCES/
> cd ./e2fsprogs-1.41.8 && rpmbuild -bb ./e2fsprogs.spec
> sudo rpm -Uhv --force /usr/src/packages/RPMS/$ARCH/e2fsprogs*.rpm

последняя операция проходит "грязно" (с ключём --force) поскольку возможен банальный конфликт базовых утилит. не страшно.

5) зато с "btrfs" у нас "просто Праздник какой-то"!

> zcat /proc/config.gz | grep -i btr

CONFIG_IPV6_SUBTREES=y
CONFIG_BTRFS_FS=m
CONFIG_BTRFS_FS_POSIX_ACL=y

6) также надо учесть, что конфиг ядра отличается чуток от "канонического". некоторые модули тупо вкомпилены в ядро. например:
'processor', 'thermal', 'fan', 'jbd', 'ext3', 'sd_mod', 'usbcore', 'ohci_hcd', 'uhci-hcd', 'ehci_hcd', 'usbhid' (может что-то ещё, список не полный, только очевидные вещи).

эт всё к тому, что не забудьте (при желании ессно) отрихтовать "/etc/sysconfig/kernel" на придмет "initrd" и всего, что с этим связано. это совершенно не критично, но, если вы конвертнули ext2/3 в ext4 - то пропишите модулёк. udev конечно придумали трусы, но мало ли. не помешает. ессно, что после подобных телодвижений стоит набрать (как минимум):

> sudo mkinitrd

7) NVIDIA-Linux-x86-185.18.31-pkg1.run прекрасно работает с нашим новым ядром (2.6.30.5)

8) AppArmor не портирован (пока).

9) стоит также помнить, что ALSA в новых ядрах "своя". не пугайтесь, если звук пропадёт и "alsaconf" пошлёт вас в известном направлении. откройте "alsamixer" с выводом всех "регуляторов" и пройдитесь по всем "ползункам". например, в случае "via82xx" помогают "*DXS*" и т.д. и т.п..

10) кроме ядра из указанный репо у вас должно пройти обновление до gtk2-2.16, что не может не радовать.

теперь со спокойной душой и чистой совестью можно понаблюдать за "хомячками" и их плясками с openSUSE-11.2.

N.B. если у вас всё работает и вы просто желаете "развлечься", то стоит оставить возможность загрузки системы с её "родных" ядер. для этого скачайте "kernel*2.6.30.5*.rpm" в локальную директорию и проведите команду установки тупо в лоб:

> rpm -i ./kernel*.rpm

так вы сохраните в системе ядра версии 2.6.27.*

удачи.

*/

2 комментария:

Анонимный комментирует...

О класс, как раз хотел попробовать последнее ядро, ибо необходимость какую-то в этом чувтсвую я

sda комментирует...

О класс, как раз хотел попробовать последнее ядро, ибо необходимость какую-то в этом чувтсвую я

прошу заметить, что ни один из рабочих вариантов так и не перевёл на "новомодные" плюшки типа ext4. т.е. что ext4, что reiser4, что btrfs вовсю пользую, НО не для /boot (/). корень системы и загрузчик - на ext2/3, reiser3.